-- by (Discord) Unangenehmer#9659 
-- Date 23.10.2020

--[[Changelog Version 1.0.0.1:
- Description adapted
- New icon
- Day limit adapts to the Seasons-Mod
- Engine may fail to start when starting the motor after reaching the limit
- Engine can stall if engine load is too high
- Bugs fixed when servicing several times
- No longer subtracts engine hours and age on first load
- Fixed a bug with "bulk buy mod" (pallet could not be bought)
- Fixed multiplayer problems--]]

-- Thanks to Ian for help with the xml!

ExtendedVehicleMaintenance = {};
ExtendedVehicleMaintenance.l10nEnv = "FS19_ExtendedVehicleMaintenance";

function ExtendedVehicleMaintenance.prerequisitesPresent(specializations)
	return true;
end;

function ExtendedVehicleMaintenance.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", ExtendedVehicleMaintenance);
	SpecializationUtil.registerEventListener(vehicleType, "onPostLoad", ExtendedVehicleMaintenance);
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", ExtendedVehicleMaintenance);
end;

function ExtendedVehicleMaintenance:onLoad(savegame)
	self.spec_ExtendedVehicleMaintenance = {};
	if self.spec_motorized ~= nil then
		self.spec_ExtendedVehicleMaintenance.gearChangeTimeBackup = {};
		self.spec_ExtendedVehicleMaintenance.gearChangeTimeBackup = self.spec_motorized.motor.gearChangeTime;

		self.spec_ExtendedVehicleMaintenance.accelerationLimitBackup = {};
		self.spec_ExtendedVehicleMaintenance.accelerationLimitBackup = self.spec_motorized.motor.accelerationLimit;

		self.spec_ExtendedVehicleMaintenance.torqueCurveBackup = {};
		self.spec_ExtendedVehicleMaintenance.torqueCurveBackup = self.spec_motorized.motor.torqueCurve.maxTime;

		self.spec_ExtendedVehicleMaintenance.Variable = {};
		self.spec_ExtendedVehicleMaintenance.Variable = 30.0;

		self.spec_ExtendedVehicleMaintenance.VariableWartezeit = {};
		self.spec_ExtendedVehicleMaintenance.VariableWartezeit = 60;

		self.spec_ExtendedVehicleMaintenance.CurrentMinuteBackup = {};
		self.spec_ExtendedVehicleMaintenance.CurrentMinuteBackup = g_currentMission.hud.environment.currentMinute;

		self.spec_ExtendedVehicleMaintenance.Minus = {};
		self.spec_ExtendedVehicleMaintenance.Minus = 30;

		self.spec_ExtendedVehicleMaintenance.WartungKnopfGedrückt = {};
		self.spec_ExtendedVehicleMaintenance.WartungKnopfGedrückt = false;

		self.spec_ExtendedVehicleMaintenance.Differenz = {};
		self.spec_ExtendedVehicleMaintenance.Differenz = 0;

		self.spec_ExtendedVehicleMaintenance.MotorActive = {};
		self.spec_ExtendedVehicleMaintenance.MotorActive = 0;

		self.spec_ExtendedVehicleMaintenance.MotorDieTimer = {};
		self.spec_ExtendedVehicleMaintenance.MotorDieTimer = -1;
		
		self.spec_ExtendedVehicleMaintenance.BackupOperatingTimeXML = {};
		self.spec_ExtendedVehicleMaintenance.BackupOperatingTimeXML = 0;
		
		self.spec_ExtendedVehicleMaintenance.DontAllowXmlNumberReset = {};
		self.spec_ExtendedVehicleMaintenance.DontAllowXmlNumberReset = false;
		
		self.spec_ExtendedVehicleMaintenance.MaintenanceTimes = {};
		self.spec_ExtendedVehicleMaintenance.MaintenanceTimes = 1;
		
		self.spec_ExtendedVehicleMaintenance.DarfNichtAusgehen = {};
		self.spec_ExtendedVehicleMaintenance.DarfNichtAusgehen = false;
		
		self.spec_ExtendedVehicleMaintenance.RandomNumber = {};
		self.spec_ExtendedVehicleMaintenance.RandomNumber = 0;
		
		self.spec_ExtendedVehicleMaintenance.SecondSound = {};
		self.spec_ExtendedVehicleMaintenance.SecondSound = 2;
		
		self.spec_ExtendedVehicleMaintenance.NumberMotorDieTimer = {};
		self.spec_ExtendedVehicleMaintenance.NumberMotorDieTimer = 0;
		-- days
		self.spec_ExtendedVehicleMaintenance.Days = {};
		self.spec_ExtendedVehicleMaintenance.Days = 36;

		self.spec_ExtendedVehicleMaintenance.SeasonsDays = {};
		self.spec_ExtendedVehicleMaintenance.SeasonsDays = 36;

		self.spec_ExtendedVehicleMaintenance.BackupAge = {};
		self.spec_ExtendedVehicleMaintenance.BackupAge = 0;
		
		self.spec_ExtendedVehicleMaintenance.BackupAgeXML = {};
		self.spec_ExtendedVehicleMaintenance.BackupAgeXML = 0;
		
		self.spec_ExtendedVehicleMaintenance.DifferenzDays = {};
		self.spec_ExtendedVehicleMaintenance.DifferenzDays = 0;
	end;
	g_currentMission.missionInfo.automaticMotorStartEnabled = false
	g_currentMission.inGameMenu.pageSettingsGame.checkAutoMotorStart:setVisible(false)
    
end;

function ExtendedVehicleMaintenance:onPostLoad(savegame)
	local spec = self.spec_ExtendedVehicleMaintenance

	if savegame ~= nil then
		spec.BackupAgeXML = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. ".ExtendedVehicleMaintenance#BackupAgeXML"), spec.BackupAgeXML)
		spec.BackupOperatingTimeXML = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. ".ExtendedVehicleMaintenance#backupOperatingTime"), spec.BackupOperatingTimeXML)
		spec.MaintenanceTimes = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. ".ExtendedVehicleMaintenance#MaintenanceTimes"), spec.MaintenanceTimes)
		spec.Differenz = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. ".ExtendedVehicleMaintenance#Differenz"), spec.Differenz)
		spec.DifferenzDays = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. ".ExtendedVehicleMaintenance#DifferenzDays"), spec.DifferenzDays)
		if Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. ".ExtendedVehicleMaintenance#BackupAgeXML")) ~= nil and Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. ".ExtendedVehicleMaintenance#backupOperatingTime")) ~= nil then
	        spec.DontAllowXmlNumberReset = true
	    end;
	end

end

function ExtendedVehicleMaintenance:saveToXMLFile(xmlFile, key, usedModNames)
	local spec = self.spec_ExtendedVehicleMaintenance

	if spec.BackupAgeXML ~= nil then
		setXMLInt(xmlFile, key .. "#BackupAgeXML", spec.BackupAgeXML)
	end
	
	if spec.BackupOperatingTimeXML ~= nil then
		setXMLInt(xmlFile, key .. "#backupOperatingTime", spec.BackupOperatingTimeXML)
	end
	
	if spec.MaintenanceTimes ~= nil then
		setXMLInt(xmlFile, key .. "#MaintenanceTimes", spec.MaintenanceTimes)
	end

    if spec.Differenz ~= nil then
		setXMLInt(xmlFile, key .. "#Differenz", spec.Differenz)
	end
	if spec.DifferenzDays ~= nil then
		setXMLInt(xmlFile, key .. "#DifferenzDays", spec.DifferenzDays)
	end
end

function ExtendedVehicleMaintenance:onUpdate(dt)
	if self.typeName == "FS19_ExtendedVehicleMaintenance.palletMaintencance" then -- searches for the Pallet
		rootNodePallet = self.rootNode;	    
	end;
	self:raiseActive()
	
	if self.spec_motorized ~= nil then
	    if self.isClient and self:getIsActiveForInput() and self.spec_ExtendedVehicleMaintenance.DontAllowXmlNumberReset ~= true then
	        self.spec_ExtendedVehicleMaintenance.BackupAgeXML = self.age
	        self.spec_ExtendedVehicleMaintenance.BackupOperatingTimeXML = self:getFormattedOperatingTime()
		    self.spec_ExtendedVehicleMaintenance.DontAllowXmlNumberReset = true
	    end;
		if self.isClient and self:getIsActiveForInput() and self.spec_ExtendedVehicleMaintenance.Variable < 0.05 or self.spec_ExtendedVehicleMaintenance.Days <= 0 then -- checks if a value is under 0
			Wartung = 1
		end;
		if self.isClient and self:getIsActiveForInput() and self.spec_ExtendedVehicleMaintenance.Variable >= 0.05 and self.spec_ExtendedVehicleMaintenance.Days > 0 then
			Wartung = 0
		end;

		if self.isClient and self:getIsActiveForInput() and Wartung == 0 then
			g_currentMission:addExtraPrintText(g_i18n:getText("information_Motor", ExtendedVehicleMaintenance.l10nEnv):format(self.spec_ExtendedVehicleMaintenance.Variable, self.spec_ExtendedVehicleMaintenance.Days)) -- 110n Text
		end;

		--hours
		if self.isClient and self:getIsActiveForInput() then
			self.spec_ExtendedVehicleMaintenance.Variable = (30 * self.spec_ExtendedVehicleMaintenance.MaintenanceTimes) - self:getFormattedOperatingTime() + self.spec_ExtendedVehicleMaintenance.Differenz + self.spec_ExtendedVehicleMaintenance.BackupOperatingTimeXML-- Operating time number
			--days
			self.spec_ExtendedVehicleMaintenance.Days = (self.spec_ExtendedVehicleMaintenance.SeasonsDays * self.spec_ExtendedVehicleMaintenance.MaintenanceTimes) - self.age + self.spec_ExtendedVehicleMaintenance.DifferenzDays + self.spec_ExtendedVehicleMaintenance.BackupAgeXML -- day number
		end;

		if g_currentMission.environment.weather.environment ~= nil then
			self.spec_ExtendedVehicleMaintenance.SeasonsDays = g_currentMission.environment.weather.environment.daysPerSeason * 4 / 2
		else
			self.spec_ExtendedVehicleMaintenance.SeasonsDays = 36
		end;
		-- Action if number is 0
		if self.isClient and self:getIsActiveForInput() and Wartung == 1 then
			g_currentMission:addExtraPrintText(g_i18n:getText("warning_wartung", ExtendedVehicleMaintenance.l10nEnv))
			self.spec_motorized.motor.gearChangeTime = 400
			self.spec_motorized.motor.accelerationLimit = 100
			self.spec_motorized.motor.torqueCurve.maxTime = 3000

			if self.spec_ExtendedVehicleMaintenance.RandomNumber == 0 then
				self.spec_ExtendedVehicleMaintenance.RandomNumber = math.random(1, 2)
			end;

			if self.spec_ExtendedVehicleMaintenance.DarfNichtAusgehen ~= true then

				--or self:getMotorLoadPercentage() >= 0.9999
				if self:getIsMotorStarted() then
					self.spec_ExtendedVehicleMaintenance.MotorDieTimer = self.spec_ExtendedVehicleMaintenance.MotorDieTimer - dt
					self.spec_ExtendedVehicleMaintenance.NumberMotorDieTimer = math.min(-self.spec_ExtendedVehicleMaintenance.MotorDieTimer / 2000, 0.9)
					-- print(self.spec_ExtendedVehicleMaintenance.NumberMotorDieTimer)
					local MaxNumber = self.spec_motorized.samples.motorStart.duration * 98 / 1000000
					if self.spec_ExtendedVehicleMaintenance.NumberMotorDieTimer >= 0.290789 then
						g_soundManager:stopSample(self.spec_motorized.samples.motorStart)
						self.spec_ExtendedVehicleMaintenance.MotorDieTimer = -1
						g_soundManager:playSample(self.spec_motorized.samples.motorStart)
						self.spec_ExtendedVehicleMaintenance.SecondSound = self.spec_ExtendedVehicleMaintenance.SecondSound - 1
					end;

					if self.spec_ExtendedVehicleMaintenance.RandomNumber == 1 and self.spec_ExtendedVehicleMaintenance.NumberMotorDieTimer >= 0.290789 and self.spec_ExtendedVehicleMaintenance.SecondSound == 0 then
						self:stopMotor()
						g_soundManager:stopSample(self.spec_motorized.samples.motorStop)
						self.spec_ExtendedVehicleMaintenance.SecondSound = 2
						self.spec_ExtendedVehicleMaintenance.RandomNumber = 0
					elseif self.spec_ExtendedVehicleMaintenance.RandomNumber == 2 and self.spec_ExtendedVehicleMaintenance.NumberMotorDieTimer >= 0.290789 and self.spec_ExtendedVehicleMaintenance.SecondSound == 1 then
						self.spec_ExtendedVehicleMaintenance.DarfNichtAusgehen = true
						self.spec_ExtendedVehicleMaintenance.RandomNumber = 0
						self.spec_ExtendedVehicleMaintenance.SecondSound = 2
					end;
				end;
			end;
			if self:getIsMotorStarted() and Wartung == 1 and OnlyWhenIsGettingActive == false then
				self.spec_ExtendedVehicleMaintenance.DarfNichtAusgehen = true
				OnlyWhenIsGettingActive = true
			else
				OnlyWhenIsGettingActive = true
			end;

			if self:getMotorLoadPercentage() > 0.999999 then
				self.spec_motorized.smoothedLoadPercentage = 0
				self:stopMotor()
			end;
			if self.spec_motorized.isMotorStarted == false then
				self.spec_ExtendedVehicleMaintenance.DarfNichtAusgehen = false
			end;
		end;
		if Wartung == 0 then
			OnlyWhenIsGettingActive = false
		end;

		-- looks for the position of the pallet and adds the action event
		if self.isClient and self:getIsActiveForInput() and g_currentMission.nodeToObject[rootNodePallet] ~= nil then
			local px, py, pz = getWorldTranslation(rootNodePallet) -- Palette
			local vx, vy, vz = getWorldTranslation(self.rootNode) -- Fahrzeug

			if MathUtil.vector3Length(px-vx, py-vy, pz-vz) > 6 then
				Check2 = 1 - 1
			end;
			if MathUtil.vector3Length(px-vx, py-vy, pz-vz) < 6 and Check2 == 0 and Wartung == 1 then
				local spec = self.spec_ExtendedVehicleMaintenance;
				spec.actionEvents = {};
				self:clearActionEventsTable(spec.actionEvents);


				local _, actionEventIdWartung = self:addActionEvent(spec.actionEvents, InputAction.VEHICLE_MAINTENANCE, self, ExtendedVehicleMaintenance.VEHICLE_MAINTENANCE, false, true, false, true, nil);

				g_inputBinding:setActionEventTextPriority(actionEventIdWartung, GS_PRIO_NORMAL)
				Check2 = 0 + 1
				test = 0 + 1
			elseif MathUtil.vector3Length(px-vx, py-vy, pz-vz) > 6 and test == 1 and self.spec_ExtendedVehicleMaintenance.actionEvents ~= nil then
				local spec = self.spec_ExtendedVehicleMaintenance;
				self:removeActionEvent(spec.actionEvents, InputAction.VEHICLE_MAINTENANCE)
				test = 1 - 1
			end;
		end;

		-- action if action event input is pressed
		if self.spec_ExtendedVehicleMaintenance.WartungKnopfGedrückt == true then
			local spec = self.spec_ExtendedVehicleMaintenance
			self:stopMotor()
			-- subtracts the time from the 1 hour 
			if self.spec_ExtendedVehicleMaintenance.CurrentMinuteBackup ~= g_currentMission.hud.environment.currentMinute then
				self.spec_ExtendedVehicleMaintenance.CurrentMinuteBackup = g_currentMission.hud.environment.currentMinute
				self.spec_ExtendedVehicleMaintenance.VariableWartezeit = self.spec_ExtendedVehicleMaintenance.VariableWartezeit - 1
			end;
			if self.isClient and self:getIsActiveForInput() then
				g_currentMission:addExtraPrintText(g_i18n:getText("information_wartung", ExtendedVehicleMaintenance.l10nEnv):format(self.spec_ExtendedVehicleMaintenance.VariableWartezeit))
			end;
			self:removeActionEvent(spec.actionEvents, InputAction.VEHICLE_MAINTENANCE)
		end;
		-- action if 1 hour is over 
		if self.spec_ExtendedVehicleMaintenance.VariableWartezeit <= 0 and self.spec_ExtendedVehicleMaintenance.WartungKnopfGedrückt == true then
			self.spec_ExtendedVehicleMaintenance.Minus = self.spec_ExtendedVehicleMaintenance.Minus + 30
			self.spec_ExtendedVehicleMaintenance.BackupAge = self.age
			self.spec_ExtendedVehicleMaintenance.WartungKnopfGedrückt = false
			self.spec_ExtendedVehicleMaintenance.BackupOperatingTimeXML = 0
			self.spec_ExtendedVehicleMaintenance.BackupAgeXML = 0
			self.spec_ExtendedVehicleMaintenance.MaintenanceTimes = self.spec_ExtendedVehicleMaintenance.MaintenanceTimes + 1
			self.spec_ExtendedVehicleMaintenance.Differenz = self:getFormattedOperatingTime() - (30 * (self.spec_ExtendedVehicleMaintenance.MaintenanceTimes - 1))
			self.spec_ExtendedVehicleMaintenance.DifferenzDays = self.age - (self.spec_ExtendedVehicleMaintenance.SeasonsDays * (self.spec_ExtendedVehicleMaintenance.MaintenanceTimes - 1))
		end;
		--print(self.spec_ExtendedVehicleMaintenance.MaintenanceTimes)
	end;
end;

function ExtendedVehicleMaintenance:VEHICLE_MAINTENANCE()
	self.spec_motorized.motor.gearChangeTime = self.spec_ExtendedVehicleMaintenance.gearChangeTimeBackup
	self.spec_motorized.motor.accelerationLimit = self.spec_ExtendedVehicleMaintenance.accelerationLimitBackup
	self.spec_motorized.motor.torqueCurve.maxTime = self.spec_ExtendedVehicleMaintenance.torqueCurveBackup
	self.spec_ExtendedVehicleMaintenance.VariableWartezeit = 60
	self.spec_ExtendedVehicleMaintenance.CurrentMinuteBackup = g_currentMission.hud.environment.currentMinute
	self.spec_ExtendedVehicleMaintenance.WartungKnopfGedrückt = true
end;